*** a/src/backend/executor/execMain.c
--- b/src/backend/executor/execMain.c
***************
*** 2097,2102 **** ExecWithCheckOptions(WCOKind kind, ResultRelInfo *resultRelInfo,
--- 2097,2121 ----
  					 * USING policy.
  					 */
  				case WCO_VIEW_CHECK:
+ 					/* See the comment in ExecConstraints(). */
+ 					if (resultRelInfo->ri_PartitionRoot)
+ 					{
+ 						HeapTuple	tuple = ExecFetchSlotTuple(slot);
+ 						TupleDesc	old_tupdesc = RelationGetDescr(rel);
+ 						TupleConversionMap *map;
+ 
+ 						rel = resultRelInfo->ri_PartitionRoot;
+ 						tupdesc = RelationGetDescr(rel);
+ 						/* a reverse map */
+ 						map = convert_tuples_by_name(old_tupdesc, tupdesc,
+ 													 gettext_noop("could not convert row type"));
+ 						if (map != NULL)
+ 						{
+ 							tuple = do_convert_tuple(tuple, map);
+ 							ExecStoreTuple(tuple, slot, InvalidBuffer, false);
+ 						}
+ 					}
+ 
  					insertedCols = GetInsertedColumns(resultRelInfo, estate);
  					updatedCols = GetUpdatedColumns(resultRelInfo, estate);
  					modifiedCols = bms_union(insertedCols, updatedCols);
*** a/src/test/regress/expected/updatable_views.out
--- b/src/test/regress/expected/updatable_views.out
***************
*** 2424,2429 **** select tableoid::regclass, * from pt;
  create view ptv_wco as select * from pt where a = 0 with check option;
  insert into ptv_wco values (1, 2);
  ERROR:  new row violates check option for view "ptv_wco"
! DETAIL:  Failing row contains (2, 1).
  drop view ptv, ptv_wco;
  drop table pt, pt1, pt11;
--- 2424,2429 ----
  create view ptv_wco as select * from pt where a = 0 with check option;
  insert into ptv_wco values (1, 2);
  ERROR:  new row violates check option for view "ptv_wco"
! DETAIL:  Failing row contains (1, 2).
  drop view ptv, ptv_wco;
  drop table pt, pt1, pt11;
